CfnCapacityReservation L1 construct
Creates a new Capacity Reservation with the specified attributes.
For more information, see Capacity Reservations in the Amazon EC2 User Guide .
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_ec2 as ec2 } from 'aws-cdk-lib';
const cfnCapacityReservation = new ec2.CfnCapacityReservation(this, 'MyCfnCapacityReservation', {
instanceCount: 123,
instancePlatform: 'instancePlatform',
instanceType: 'instanceType',
// the properties below are optional
availabilityZone: 'availabilityZone',
availabilityZoneId: 'availabilityZoneId',
ebsOptimized: false,
endDate: 'endDate',
endDateType: 'endDateType',
ephemeralStorage: false,
instanceMatchCriteria: 'instanceMatchCriteria',
outPostArn: 'outPostArn',
placementGroupArn: 'placementGroupArn',
tagSpecifications: [{
resourceType: 'resourceType',
tags: [{
key: 'key',
value: 'value',
}],
}],
tenancy: 'tenancy',
unusedReservationBillingOwnerId: 'unusedReservationBillingOwnerId',
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_ec2 as ec2
cfn_capacity_reservation = ec2.CfnCapacityReservation(self, "MyCfnCapacityReservation",
instance_count=123,
instance_platform="instancePlatform",
instance_type="instanceType",
# the properties below are optional
availability_zone="availabilityZone",
availability_zone_id="availabilityZoneId",
ebs_optimized=False,
end_date="endDate",
end_date_type="endDateType",
ephemeral_storage=False,
instance_match_criteria="instanceMatchCriteria",
out_post_arn="outPostArn",
placement_group_arn="placementGroupArn",
tag_specifications=[ec2.CfnCapacityReservation.TagSpecificationProperty(
resource_type="resourceType",
tags=[CfnTag(
key="key",
value="value"
)]
)],
tenancy="tenancy",
unused_reservation_billing_owner_id="unusedReservationBillingOwnerId"
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.ec2.*;
CfnCapacityReservation cfnCapacityReservation = CfnCapacityReservation.Builder.create(this, "MyCfnCapacityReservation")
.instanceCount(123)
.instancePlatform("instancePlatform")
.instanceType("instanceType")
// the properties below are optional
.availabilityZone("availabilityZone")
.availabilityZoneId("availabilityZoneId")
.ebsOptimized(false)
.endDate("endDate")
.endDateType("endDateType")
.ephemeralStorage(false)
.instanceMatchCriteria("instanceMatchCriteria")
.outPostArn("outPostArn")
.placementGroupArn("placementGroupArn")
.tagSpecifications(List.of(TagSpecificationProperty.builder()
.resourceType("resourceType")
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.build()))
.tenancy("tenancy")
.unusedReservationBillingOwnerId("unusedReservationBillingOwnerId")
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.EC2;
var cfnCapacityReservation = new CfnCapacityReservation(this, "MyCfnCapacityReservation", new CfnCapacityReservationProps {
InstanceCount = 123,
InstancePlatform = "instancePlatform",
InstanceType = "instanceType",
// the properties below are optional
AvailabilityZone = "availabilityZone",
AvailabilityZoneId = "availabilityZoneId",
EbsOptimized = false,
EndDate = "endDate",
EndDateType = "endDateType",
EphemeralStorage = false,
InstanceMatchCriteria = "instanceMatchCriteria",
OutPostArn = "outPostArn",
PlacementGroupArn = "placementGroupArn",
TagSpecifications = new [] { new TagSpecificationProperty {
ResourceType = "resourceType",
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} }
} },
Tenancy = "tenancy",
UnusedReservationBillingOwnerId = "unusedReservationBillingOwnerId"
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnCapacityReservation := awscdk.Aws_ec2.NewCfnCapacityReservation(this, jsii.String("MyCfnCapacityReservation"), &CfnCapacityReservationProps{
InstanceCount: jsii.Number(123),
InstancePlatform: jsii.String("instancePlatform"),
InstanceType: jsii.String("instanceType"),
// the properties below are optional
AvailabilityZone: jsii.String("availabilityZone"),
AvailabilityZoneId: jsii.String("availabilityZoneId"),
EbsOptimized: jsii.Boolean(false),
EndDate: jsii.String("endDate"),
EndDateType: jsii.String("endDateType"),
EphemeralStorage: jsii.Boolean(false),
InstanceMatchCriteria: jsii.String("instanceMatchCriteria"),
OutPostArn: jsii.String("outPostArn"),
PlacementGroupArn: jsii.String("placementGroupArn"),
TagSpecifications: []interface{}{
&TagSpecificationProperty{
ResourceType: jsii.String("resourceType"),
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
},
},
Tenancy: jsii.String("tenancy"),
UnusedReservationBillingOwnerId: jsii.String("unusedReservationBillingOwnerId"),
})
Initializer
new CfnCapacityReservation(scope: Construct, id: string, props: CfnCapacityReservationProps)
CfnCapacityReservation(scope: Construct, id: str, props: CfnCapacityReservationProps)
new CfnCapacityReservation(Construct scope, String id, CfnCapacityReservationProps props)
new CfnCapacityReservation(Construct scope, string id, CfnCapacityReservationProps props)
NewCfnCapacityReservation(Scope Construct, Id *string, Props CfnCapacityReservationProps)
Construct Props
availabilityZoneoptionalstringavailability_zoneoptionalstravailabilityZoneoptionalStringAvailabilityZoneoptionalstringAvailabilityZoneoptional*string#availabilityZoneIdoptionalstringavailability_zone_idoptionalstravailabilityZoneIdoptionalStringAvailabilityZoneIdoptionalstringAvailabilityZoneIdoptional*string#ebsOptimizedoptionalboolean | IResolvableebs_optimizedoptionaltyping.Union[bool, IResolvable]ebsOptimizedoptionalBooleanEbsOptimizedoptionalboolEbsOptimizedoptionalinterface{}#notes
This optimization provides dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal I/O performance. This optimization isn't available with all instance types. Additional usage charges apply when using an EBS- optimized instance.
endDateoptionalstringend_dateoptionalstrendDateoptionalStringEndDateoptionalstringEndDateoptional*string#notes
When a Capacity Reservation expires, the reserved capacity is released and you can no longer launch instances into it. The Capacity Reservation's state changes to expired when it reaches its end date and time.
You must provide an EndDate value if EndDateType is limited . Omit EndDate if EndDateType is unlimited .
If the EndDateType is limited , the Capacity Reservation is cancelled within an hour from the specified time. For example, if you specify 5/31/2019, 13:30:55, the Capacity Reservation is guaranteed to end between 13:30:55 and 14:30:55 on 5/31/2019.
If you are requesting a future-dated Capacity Reservation, you can't specify an end date and time that is within the commitment duration.
endDateTypeoptionalstringend_date_typeoptionalstrendDateTypeoptionalStringEndDateTypeoptionalstringEndDateTypeoptional*string#notes
A Capacity Reservation can have one of the following end types:
unlimited- The Capacity Reservation remains active until you explicitly cancel it. Do not provide anEndDateif theEndDateTypeisunlimited.limited- The Capacity Reservation expires automatically at a specified date and time. You must provide anEndDatevalue if theEndDateTypevalue islimited.
ephemeralStorageoptionalboolean | IResolvableephemeral_storageoptionaltyping.Union[bool, IResolvable]ephemeralStorageoptionalBooleanEphemeralStorageoptionalboolEphemeralStorageoptionalinterface{}#instanceCountnumberinstance_countint | floatinstanceCountNumberInstanceCountdoubleInstanceCount*float64required#notes
You can request future-dated Capacity Reservations for an instance count with a minimum of 32 vCPUs. For example, if you request a future-dated Capacity Reservation for
m5.xlargeinstances, you must request at least 8 instances ( 8 * m5.xlarge = 32 vCPUs ).
Valid range: 1 - 1000
instanceMatchCriteriaoptionalstringinstance_match_criteriaoptionalstrinstanceMatchCriteriaoptionalStringInstanceMatchCriteriaoptionalstringInstanceMatchCriteriaoptional*string#notes
open- The Capacity Reservation automatically matches all instances that have matching attributes (instance type, platform, and Availability Zone). Instances that have matching attributes run in the Capacity Reservation automatically without specifying any additional parameters.targeted- The Capacity Reservation only accepts instances that have matching attributes (instance type, platform, and Availability Zone), and explicitly target the Capacity Reservation. This ensures that only permitted instances can use the reserved capacity.
If you are requesting a future-dated Capacity Reservation, you must specify
targeted.
Default: open
instancePlatformstringinstance_platformstrinstancePlatformStringInstancePlatformstringInstancePlatform*stringrequired#notes
You can request future-dated Capacity Reservations for instance types in the C, M, R, I, T, and G instance families only.
For more information, see Instance types in the Amazon EC2 User Guide .
outPostArnoptionalstringout_post_arnoptionalstroutPostArnoptionalStringOutPostArnoptionalstringOutPostArnoptional*string#The Amazon Resource Name (ARN) of the Outpost on which to create the Capacity Reservation.
placementGroupArnoptionalstringplacement_group_arnoptionalstrplacementGroupArnoptionalStringPlacementGroupArnoptionalstringPlacementGroupArnoptional*string#notes
The Amazon Resource Name (ARN) of the cluster placement group in which to create the Capacity Reservation. For more information, see Capacity Reservations for cluster placement groups in the Amazon EC2 User Guide .
tagSpecificationsoptionalIResolvable | IResolvable | CfnCapacityReservation.TagSpecificationProperty[]tag_specificationsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, TagSpecificationProperty]]]tagSpecificationsoptionalIResolvableTagSpecificationsoptionalIResolvableTagSpecificationsoptionalinterface{}#tenancyoptionalstringtenancyoptionalstrtenancyoptionalStringTenancyoptionalstringTenancyoptional*string#default- The Capacity Reservation is created on hardware that is shared with other AWS accounts .dedicated- The Capacity Reservation is created on single-tenant hardware that is dedicated to a single AWS account .
unusedReservationBillingOwnerIdoptionalstringunused_reservation_billing_owner_idoptionalstrunusedReservationBillingOwnerIdoptionalStringUnusedReservationBillingOwnerIdoptionalstringUnusedReservationBillingOwnerIdoptional*string#notes
A request will be sent to the specified account. That account must accept the request for the billing to be assigned to their account. For more information, see Billing assignment for shared Amazon EC2 Capacity Reservations .
You can assign billing only for shared Capacity Reservations. To share a Capacity Reservation, you must add it to a resource share. For more information, see AWS::RAM::ResourceShare .
Properties
attrAvailabilityZonestringattr_availability_zonestrattrAvailabilityZoneStringAttrAvailabilityZonestringAttrAvailabilityZone*stringrequired#For example: us-east-1a .
attrAvailableInstanceCountnumberattr_available_instance_countint | floatattrAvailableInstanceCountNumberAttrAvailableInstanceCountdoubleAttrAvailableInstanceCount*float64required#For example: 9 .
attrCapacityAllocationSetIResolvableattr_capacity_allocation_setIResolvableattrCapacityAllocationSetIResolvableAttrCapacityAllocationSetIResolvableAttrCapacityAllocationSetIResolvablerequired#attrCapacityReservationArnstringattr_capacity_reservation_arnstrattrCapacityReservationArnStringAttrCapacityReservationArnstringAttrCapacityReservationArn*stringrequired#attrCapacityReservationFleetIdstringattr_capacity_reservation_fleet_idstrattrCapacityReservationFleetIdStringAttrCapacityReservationFleetIdstringAttrCapacityReservationFleetId*stringrequired#Only valid for Capacity Reservations that were created by a Capacity Reservation Fleet.
attrCommitmentInfoIResolvableattr_commitment_infoIResolvableattrCommitmentInfoIResolvableAttrCommitmentInfoIResolvableAttrCommitmentInfoIResolvablerequired#attrCreateDatestringattr_create_datestrattrCreateDateStringAttrCreateDatestringAttrCreateDate*stringrequired#attrDeliveryPreferencestringattr_delivery_preferencestrattrDeliveryPreferenceStringAttrDeliveryPreferencestringAttrDeliveryPreference*stringrequired#incremental indicates that the requested capacity is delivered in addition to any running instances and reserved capacity that you have in your account at the requested date and time.
attrInstanceTypestringattr_instance_typestrattrInstanceTypeStringAttrInstanceTypestringAttrInstanceType*stringrequired#For example: m4.large .
attrReservationTypestringattr_reservation_typestrattrReservationTypeStringAttrReservationTypestringAttrReservationType*stringrequired#attrStartDatestringattr_start_datestrattrStartDateStringAttrStartDatestringAttrStartDate*stringrequired#notes
active- The capacity is available for use.expired- The Capacity Reservation expired automatically at the date and time specified in your reservation request. The reserved capacity is no longer available for your use.cancelled- The Capacity Reservation was canceled. The reserved capacity is no longer available for your use.pending- The Capacity Reservation request was successful but the capacity provisioning is still pending.failed- The Capacity Reservation request has failed. A request can fail due to request parameters that are not valid, capacity constraints, or instance limit constraints. You can view a failed request for 60 minutes.scheduled- ( Future-dated Capacity Reservations ) The future-dated Capacity Reservation request was approved and the Capacity Reservation is scheduled for delivery on the requested start date.payment-pending- ( Capacity Blocks ) The upfront payment has not been processed yet.payment-failed- ( Capacity Blocks ) The upfront payment was not processed in the 12-hour time frame. Your Capacity Block was released.assessing- ( Future-dated Capacity Reservations ) Amazon EC2 is assessing your request for a future-dated Capacity Reservation.delayed- ( Future-dated Capacity Reservations ) Amazon EC2 encountered a delay in provisioning the requested future-dated Capacity Reservation. Amazon EC2 is unable to deliver the requested capacity by the requested start date and time.unsupported- ( Future-dated Capacity Reservations ) Amazon EC2 can't support the future-dated Capacity Reservation request due to capacity constraints. You can view unsupported requests for 30 days. The Capacity Reservation will not be delivered.
For example: dedicated .
attrTotalInstanceCountnumberattr_total_instance_countint | floatattrTotalInstanceCountNumberAttrTotalInstanceCountdoubleAttrTotalInstanceCount*float64required#For example: 15 .
availabilityZonemay be undefinedstringavailability_zonemay be undefinedstravailabilityZonemay be undefinedStringAvailabilityZonemay be undefinedstringAvailabilityZonemay be undefined*string#availabilityZoneIdmay be undefinedstringavailability_zone_idmay be undefinedstravailabilityZoneIdmay be undefinedStringAvailabilityZoneIdmay be undefinedstringAvailabilityZoneIdmay be undefined*string#capacityReservationRefCapacityReservationReferencecapacity_reservation_refCapacityReservationReferencecapacityReservationRefCapacityReservationReferenceCapacityReservationRefCapacityReservationReferenceCapacityReservationRefCapacityReservationReferencerequired#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#ebsOptimizedmay be undefinedboolean | IResolvableebs_optimizedmay be undefinedtyping.Union[bool, IResolvable]ebsOptimizedmay be undefinedBooleanEbsOptimizedmay be undefinedboolEbsOptimizedmay be undefinedinterface{}#endDatemay be undefinedstringend_datemay be undefinedstrendDatemay be undefinedStringEndDatemay be undefinedstringEndDatemay be undefined*string#endDateTypemay be undefinedstringend_date_typemay be undefinedstrendDateTypemay be undefinedStringEndDateTypemay be undefinedstringEndDateTypemay be undefined*string#ephemeralStoragemay be undefinedboolean | IResolvableephemeral_storagemay be undefinedtyping.Union[bool, IResolvable]ephemeralStoragemay be undefinedBooleanEphemeralStoragemay be undefinedboolEphemeralStoragemay be undefinedinterface{}#instanceCountnumberinstance_countint | floatinstanceCountNumberInstanceCountdoubleInstanceCount*float64required#instanceMatchCriteriamay be undefinedstringinstance_match_criteriamay be undefinedstrinstanceMatchCriteriamay be undefinedStringInstanceMatchCriteriamay be undefinedstringInstanceMatchCriteriamay be undefined*string#The options include:.
instancePlatformstringinstance_platformstrinstancePlatformStringInstancePlatformstringInstancePlatform*stringrequired#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
outPostArnmay be undefinedstringout_post_arnmay be undefinedstroutPostArnmay be undefinedStringOutPostArnmay be undefinedstringOutPostArnmay be undefined*string#placementGroupArnmay be undefinedstringplacement_group_arnmay be undefinedstrplacementGroupArnmay be undefinedStringPlacementGroupArnmay be undefinedstringPlacementGroupArnmay be undefined*string#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
CfnElements must be defined within a stack scope (directly or indirectly).
tagSpecificationsmay be undefinedIResolvable | IResolvable | CfnCapacityReservation.TagSpecificationProperty[]tag_specificationsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, TagSpecificationProperty]]]tagSpecificationsmay be undefinedIResolvableTagSpecificationsmay be undefinedIResolvableTagSpecificationsmay be undefinedinterface{}#tenancymay be undefinedstringtenancymay be undefinedstrtenancymay be undefinedStringTenancymay be undefinedstringTenancymay be undefined*string#A Capacity Reservation can have one of the following tenancy settings:.
unusedReservationBillingOwnerIdmay be undefinedstringunused_reservation_billing_owner_idmay be undefinedstrunusedReservationBillingOwnerIdmay be undefinedStringUnusedReservationBillingOwnerIdmay be undefinedstringUnusedReservationBillingOwnerIdmay be undefined*string#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForCapacityReservation(resource: ICapacityReservationRef): string@staticmethod def arn_for_capacity_reservation(resource: ICapacityReservationRef) -> strpublic static String arnForCapacityReservation(ICapacityReservationRef resource)public static string ArnForCapacityReservation(ICapacityReservationRef resource)func ArnForCapacityReservation(Resource ICapacityReservationRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#fromCapacityReservationArn(scope: Construct, id: string, arn: string): ICapacityReservationRef@staticmethod def from_capacity_reservation_arn(scope: Construct, id: str, arn: str) -> ICapacityReservationRefpublic static ICapacityReservationRef fromCapacityReservationArn(Construct scope, String id, String arn)public static ICapacityReservationRef FromCapacityReservationArn(Construct scope, string id, string arn)func FromCapacityReservationArn(Scope Construct, Id *string, Arn *string) ICapacityReservationRefstatic#fromCapacityReservationId(scope: Construct, id: string, capacityReservationId: string): ICapacityReservationRef@staticmethod def from_capacity_reservation_id(scope: Construct, id: str, capacity_reservation_id: str) -> ICapacityReservationRefpublic static ICapacityReservationRef fromCapacityReservationId(Construct scope, String id, String capacityReservationId)public static ICapacityReservationRef FromCapacityReservationId(Construct scope, string id, string capacityReservationId)func FromCapacityReservationId(Scope Construct, Id *string, CapacityReservationId *string) ICapacityReservationRefstatic#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnCapacityReservation(x: any): boolean@staticmethod def is_cfn_capacity_reservation(x: Any) -> boolpublic static Boolean isCfnCapacityReservation(Object x)public static bool IsCfnCapacityReservation(object x)func IsCfnCapacityReservation(X interface{}) *boolstatic#isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.